"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_tags_1 = require("common-tags");
function getAppOwner(sdk, appName) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, exitWithExpectedError, selectFromList, _, applications, entries, selected;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4, Promise.resolve().then(function () { return require('../utils/patterns'); })];
                case 1:
                    _a = _b.sent(), exitWithExpectedError = _a.exitWithExpectedError, selectFromList = _a.selectFromList;
                    return [4, Promise.resolve().then(function () { return require('lodash'); })];
                case 2:
                    _ = _b.sent();
                    return [4, sdk.models.application.getAll({
                            $expand: {
                                user: {
                                    $select: ['username'],
                                },
                            },
                            $filter: {
                                app_name: appName,
                            },
                            $select: ['id'],
                        })];
                case 3:
                    applications = _b.sent();
                    if (applications == null || applications.length === 0) {
                        exitWithExpectedError(common_tags_1.stripIndent(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t\tNo applications found with name: ", ".\n\n\t\t\tThis could mean that the application does not exist, or you do\n\t\t\tnot have the permissions required to access it."], ["\n\t\t\tNo applications found with name: ", ".\n\n\t\t\tThis could mean that the application does not exist, or you do\n\t\t\tnot have the permissions required to access it."])), appName));
                    }
                    if (applications.length === 1) {
                        return [2, _.get(applications, '[0].user[0].username')];
                    }
                    entries = _.map(applications, function (app) {
                        var username = _.get(app, 'user[0].username');
                        return {
                            name: username + "/" + appName,
                            extra: username,
                        };
                    });
                    return [4, selectFromList(entries.length + " applications found with that name, please select the application you would like to push to", entries)];
                case 4:
                    selected = _b.sent();
                    return [2, selected.extra];
            }
        });
    });
}
exports.push = {
    signature: 'push <application>',
    description: 'Start a remote build on the resin.io cloud build servers',
    help: common_tags_1.stripIndent(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t\tThis command can be used to start a build on the remote\n\t\tresin.io cloud builders. The given source directory will be sent to the\n\t\tresin.io builder, and the build will proceed. This can be used as a drop-in\n\t\treplacement for git push to deploy.\n\n\t\tExamples:\n\n\t\t\t$ resin push myApp\n\t\t\t$ resin push myApp --source <source directory>\n\t\t\t$ resin push myApp -s <source directory>\n\t"], ["\n\t\tThis command can be used to start a build on the remote\n\t\tresin.io cloud builders. The given source directory will be sent to the\n\t\tresin.io builder, and the build will proceed. This can be used as a drop-in\n\t\treplacement for git push to deploy.\n\n\t\tExamples:\n\n\t\t\t$ resin push myApp\n\t\t\t$ resin push myApp --source <source directory>\n\t\t\t$ resin push myApp -s <source directory>\n\t"]))),
    permission: 'user',
    options: [
        {
            signature: 'source',
            alias: 's',
            description: 'The source that should be sent to the resin builder to be built (defaults to the current directory)',
            parameter: 'source',
        },
        {
            signature: 'emulated',
            alias: 'e',
            description: 'Force an emulated build to occur on the remote builder',
            boolean: true,
        },
        {
            signature: 'nocache',
            alias: 'c',
            description: "Don't use cache when building this project",
            boolean: true,
        },
    ],
    action: function (params, options, done) {
        return __awaiter(this, void 0, void 0, function () {
            var sdk, Bluebird, remote, exitWithExpectedError, app, source;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, Promise.resolve().then(function () { return require('resin-sdk'); })];
                    case 1:
                        sdk = (_a.sent()).fromSharedOptions();
                        return [4, Promise.resolve().then(function () { return require('bluebird'); })];
                    case 2:
                        Bluebird = _a.sent();
                        return [4, Promise.resolve().then(function () { return require('../utils/remote-build'); })];
                    case 3:
                        remote = _a.sent();
                        return [4, Promise.resolve().then(function () { return require('../utils/patterns'); })];
                    case 4:
                        exitWithExpectedError = (_a.sent()).exitWithExpectedError;
                        app = params.application;
                        if (app == null) {
                            exitWithExpectedError('You must specify an application');
                        }
                        source = options.source || '.';
                        if (process.env.DEBUG) {
                            console.log("[debug] Using " + source + " as build source");
                        }
                        Bluebird.join(sdk.auth.getToken(), sdk.settings.get('resinUrl'), getAppOwner(sdk, app), function (token, baseUrl, owner) {
                            var opts = {
                                emulated: options.emulated,
                                nocache: options.nocache,
                            };
                            var args = {
                                app: app,
                                owner: owner,
                                source: source,
                                auth: token,
                                baseUrl: baseUrl,
                                sdk: sdk,
                                opts: opts,
                            };
                            return remote.startRemoteBuild(args);
                        }).nodeify(done);
                        return [2];
                }
            });
        });
    },
};
var templateObject_1, templateObject_2;
//# sourceMappingURL=push.js.map