"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Capitano = require("capitano");
var _ = require("lodash");
var Mixpanel = require("mixpanel");
var Raven = require("raven");
var Promise = require("bluebird");
var ResinSdk = require("resin-sdk");
var packageJSON = require("../package.json");
var resin = ResinSdk.fromSharedOptions();
var getMatchCommandAsync = Promise.promisify(Capitano.state.getMatchCommand);
var getMixpanel = _.memoize(function () {
    return resin.models.config
        .getAll()
        .get('mixpanelToken')
        .then(Mixpanel.init);
});
function trackCommand(capitanoCli) {
    return Promise.props({
        resinUrl: resin.settings.get('resinUrl'),
        username: resin.auth.whoami().catchReturn(undefined),
        mixpanel: getMixpanel(),
    })
        .then(function (_a) {
        var username = _a.username, resinUrl = _a.resinUrl, mixpanel = _a.mixpanel;
        return getMatchCommandAsync(capitanoCli.command).then(function (command) {
            Raven.mergeContext({
                user: {
                    id: username,
                    username: username,
                },
            });
            return mixpanel.track("[CLI] " + command.signature.toString(), {
                distinct_id: username,
                argv: process.argv.join(' '),
                version: packageJSON.version,
                node: process.version,
                arch: process.arch,
                resinUrl: resinUrl,
                platform: process.platform,
                command: capitanoCli,
            });
        });
    })
        .timeout(100)
        .catchReturn(undefined);
}
exports.trackCommand = trackCommand;
//# sourceMappingURL=events.js.map