"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_tags_1 = require("common-tags");
var helpers_1 = require("./helpers");
var ssh_1 = require("./ssh");
var MIN_RESINOS_VERSION = 'v2.14.0';
function join(logger, sdk, deviceHostnameOrIp, appName) {
    return __awaiter(this, void 0, void 0, function () {
        var isLoggedIn, deviceIp, deviceType, app, config, platformUrl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    logger.logDebug('Checking login...');
                    return [4, sdk.auth.isLoggedIn()];
                case 1:
                    isLoggedIn = _a.sent();
                    if (!!isLoggedIn) return [3, 3];
                    logger.logInfo("Looks like you're not logged in yet!");
                    logger.logInfo("Let's go through a quick wizard to get you started.\n");
                    return [4, helpers_1.runCommand('login')];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    logger.logDebug('Determining device...');
                    return [4, getOrSelectLocalDevice(deviceHostnameOrIp)];
                case 4:
                    deviceIp = _a.sent();
                    return [4, assertDeviceIsCompatible(deviceIp)];
                case 5:
                    _a.sent();
                    logger.logDebug("Using device: " + deviceIp);
                    logger.logDebug('Determining device type...');
                    return [4, getDeviceType(deviceIp)];
                case 6:
                    deviceType = _a.sent();
                    logger.logDebug("Device type: " + deviceType);
                    logger.logDebug('Determining application...');
                    return [4, getOrSelectApplication(sdk, deviceType, appName)];
                case 7:
                    app = _a.sent();
                    logger.logDebug("Using application: " + app.app_name + " (" + app.device_type + ")");
                    if (app.device_type != deviceType) {
                        logger.logDebug("Forcing device type to: " + deviceType);
                        app.device_type = deviceType;
                    }
                    logger.logDebug('Generating application config...');
                    return [4, generateApplicationConfig(sdk, app)];
                case 8:
                    config = _a.sent();
                    logger.logDebug("Using config: " + JSON.stringify(config, null, 2));
                    logger.logDebug('Configuring...');
                    return [4, configure(deviceIp, config)];
                case 9:
                    _a.sent();
                    logger.logDebug('All done.');
                    return [4, sdk.settings.get('resinUrl')];
                case 10:
                    platformUrl = _a.sent();
                    logger.logSuccess("Device successfully joined " + platformUrl + "!");
                    return [2];
            }
        });
    });
}
exports.join = join;
function leave(logger, _sdk, deviceHostnameOrIp) {
    return __awaiter(this, void 0, void 0, function () {
        var deviceIp;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    logger.logDebug('Determining device...');
                    return [4, getOrSelectLocalDevice(deviceHostnameOrIp)];
                case 1:
                    deviceIp = _a.sent();
                    return [4, assertDeviceIsCompatible(deviceIp)];
                case 2:
                    _a.sent();
                    logger.logDebug("Using device: " + deviceIp);
                    logger.logDebug('Deconfiguring...');
                    return [4, deconfigure(deviceIp)];
                case 3:
                    _a.sent();
                    logger.logDebug('All done.');
                    logger.logSuccess('Device successfully left the platform.');
                    return [2];
            }
        });
    });
}
exports.leave = leave;
function execCommand(deviceIp, cmd, msg) {
    return __awaiter(this, void 0, void 0, function () {
        var through, visuals, spinner, innerSpinner, stream;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.resolve().then(function () { return require('through2'); })];
                case 1:
                    through = _a.sent();
                    return [4, Promise.resolve().then(function () { return require('resin-cli-visuals'); })];
                case 2:
                    visuals = _a.sent();
                    spinner = new visuals.Spinner("[" + deviceIp + "] Connecting...");
                    innerSpinner = spinner.spinner;
                    stream = through(function (data, _enc, cb) {
                        innerSpinner.setSpinnerTitle("%s [" + deviceIp + "] " + msg);
                        cb(null, data);
                    });
                    spinner.start();
                    return [4, ssh_1.exec(deviceIp, cmd, stream)];
                case 3:
                    _a.sent();
                    spinner.stop();
                    return [2];
            }
        });
    });
}
function configure(deviceIp, config) {
    return __awaiter(this, void 0, void 0, function () {
        var json, b64, str;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    json = JSON.stringify(config);
                    b64 = Buffer.from(json).toString('base64');
                    str = "\"$(base64 -d <<< " + b64 + ")\"";
                    return [4, execCommand(deviceIp, "os-config join '" + str + "'", 'Configuring...')];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
function deconfigure(deviceIp) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, execCommand(deviceIp, 'os-config leave', 'Configuring...')];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
function assertDeviceIsCompatible(deviceIp) {
    return __awaiter(this, void 0, void 0, function () {
        var exitWithExpectedError, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.resolve().then(function () { return require('../utils/patterns'); })];
                case 1:
                    exitWithExpectedError = (_a.sent()).exitWithExpectedError;
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4, ssh_1.execBuffered(deviceIp, 'os-config --version')];
                case 3:
                    _a.sent();
                    return [3, 5];
                case 4:
                    err_1 = _a.sent();
                    exitWithExpectedError(common_tags_1.stripIndent(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t\tDevice \"", "\" is incompatible and cannot join or leave an application.\n\t\t\tPlease select or provision device with resinOS newer than ", "."], ["\n\t\t\tDevice \"", "\" is incompatible and cannot join or leave an application.\n\t\t\tPlease select or provision device with resinOS newer than ", "."])), deviceIp, MIN_RESINOS_VERSION));
                    return [3, 5];
                case 5: return [2];
            }
        });
    });
}
function getDeviceType(deviceIp) {
    return __awaiter(this, void 0, void 0, function () {
        var output, match;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, ssh_1.execBuffered(deviceIp, 'cat /etc/os-release')];
                case 1:
                    output = _a.sent();
                    match = /^SLUG="([^"]+)"$/m.exec(output);
                    if (!match) {
                        throw new Error('Failed to determine device type');
                    }
                    return [2, match[1]];
            }
        });
    });
}
function getOrSelectLocalDevice(deviceIp) {
    return __awaiter(this, void 0, void 0, function () {
        var through, ip, stream, sudo, command;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (deviceIp) {
                        return [2, deviceIp];
                    }
                    return [4, Promise.resolve().then(function () { return require('through2'); })];
                case 1:
                    through = _a.sent();
                    ip = null;
                    stream = through(function (data, _enc, cb) {
                        var match = /^==> Selected device: (.*)$/m.exec(data.toString());
                        if (match) {
                            ip = match[1];
                            cb();
                        }
                        else {
                            cb(null, data);
                        }
                    });
                    stream.pipe(process.stderr);
                    return [4, Promise.resolve().then(function () { return require('../utils/helpers'); })];
                case 2:
                    sudo = (_a.sent()).sudo;
                    command = process.argv.slice(0, 2).concat(['internal', 'scandevices']);
                    return [4, sudo(command, {
                            stderr: stream,
                            msg: 'Scanning for local devices. If asked, please type your computer password.',
                        })];
                case 3:
                    _a.sent();
                    if (!ip) {
                        throw new Error('No device selected');
                    }
                    return [2, ip];
            }
        });
    });
}
function getOrSelectApplication(sdk, deviceType, appName) {
    return __awaiter(this, void 0, void 0, function () {
        var _, form, selectFromList, allDeviceTypes, deviceTypeManifest, compatibleDeviceTypes, options, applications_1, shouldCreateApp, match, applications, shouldCreateApp, validApplications;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.resolve().then(function () { return require('lodash'); })];
                case 1:
                    _ = _a.sent();
                    return [4, Promise.resolve().then(function () { return require('resin-cli-form'); })];
                case 2:
                    form = _a.sent();
                    return [4, Promise.resolve().then(function () { return require('../utils/patterns'); })];
                case 3:
                    selectFromList = (_a.sent()).selectFromList;
                    return [4, sdk.models.config.getDeviceTypes()];
                case 4:
                    allDeviceTypes = _a.sent();
                    deviceTypeManifest = _.find(allDeviceTypes, { slug: deviceType });
                    if (!deviceTypeManifest) {
                        throw new Error("\"" + deviceType + "\" is not a valid device type");
                    }
                    compatibleDeviceTypes = _(allDeviceTypes)
                        .filter({ arch: deviceTypeManifest.arch })
                        .map(function (type) { return type.slug; })
                        .value();
                    options = {
                        $expand: { user: { $select: ['username'] } },
                        $filter: { device_type: { $in: compatibleDeviceTypes } },
                    };
                    if (!!appName) return [3, 8];
                    return [4, sdk.models.application.getAll(options)];
                case 5:
                    applications_1 = _a.sent();
                    if (!(applications_1.length === 0)) return [3, 7];
                    return [4, form.ask({
                            message: 'You have no applications this device can join.\n' +
                                'Would you like to create one now?',
                            type: 'confirm',
                            default: true,
                        })];
                case 6:
                    shouldCreateApp = _a.sent();
                    if (shouldCreateApp) {
                        return [2, createApplication(sdk, deviceType)];
                    }
                    process.exit(1);
                    _a.label = 7;
                case 7: return [2, selectFromList('Select application', _.map(applications_1, function (app) { return _.merge({ name: app.app_name }, app); }))];
                case 8:
                    options.$filter = { app_name: appName };
                    match = appName.split('/');
                    if (match.length > 1) {
                        options.$expand.user.$filter = { username: match[0] };
                        options.$filter.app_name = match[1];
                    }
                    return [4, sdk.pine.get({
                            resource: 'application',
                            options: options,
                        })];
                case 9:
                    applications = _a.sent();
                    if (!(applications.length === 0)) return [3, 11];
                    return [4, form.ask({
                            message: "No application found with name \"" + appName + "\".\n" +
                                'Would you like to create it now?',
                            type: 'confirm',
                            default: true,
                        })];
                case 10:
                    shouldCreateApp = _a.sent();
                    if (shouldCreateApp) {
                        return [2, createApplication(sdk, deviceType, options.$filter.app_name)];
                    }
                    process.exit(1);
                    _a.label = 11;
                case 11:
                    validApplications = applications.filter(function (app) {
                        return _.includes(compatibleDeviceTypes, app.device_type);
                    });
                    if (validApplications.length === 1) {
                        return [2, validApplications[0]];
                    }
                    return [2, selectFromList('Found multiple applications with that name; please select the one to use', _.map(validApplications, function (app) {
                            var owner = _.get(app, 'user[0].username');
                            return _.merge({ name: owner + "/" + app.app_name }, app);
                        }))];
            }
        });
    });
}
function createApplication(sdk, deviceType, name) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        var form, validation, patterns, user, queryOptions, appName;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.resolve().then(function () { return require('resin-cli-form'); })];
                case 1:
                    form = _a.sent();
                    return [4, Promise.resolve().then(function () { return require('./validation'); })];
                case 2:
                    validation = _a.sent();
                    return [4, Promise.resolve().then(function () { return require('./patterns'); })];
                case 3:
                    patterns = _a.sent();
                    return [4, sdk.auth.getUserId()];
                case 4:
                    user = _a.sent();
                    queryOptions = {
                        $filter: { user: user },
                    };
                    return [4, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                            var appName_1, err_2, err_3;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!true) return [3, 9];
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 7, , 8]);
                                        return [4, form.ask({
                                                message: 'Enter a name for your new application:',
                                                type: 'input',
                                                default: name,
                                                validate: validation.validateApplicationName,
                                            })];
                                    case 2:
                                        appName_1 = _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        _a.trys.push([3, 5, , 6]);
                                        return [4, sdk.models.application.get(appName_1, queryOptions)];
                                    case 4:
                                        _a.sent();
                                        patterns.printErrorMessage('You already have an application with that name; please choose another.');
                                        return [3, 0];
                                    case 5:
                                        err_2 = _a.sent();
                                        return [2, resolve(appName_1)];
                                    case 6: return [3, 8];
                                    case 7:
                                        err_3 = _a.sent();
                                        return [2, reject(err_3)];
                                    case 8: return [3, 0];
                                    case 9: return [2];
                                }
                            });
                        }); })];
                case 5:
                    appName = _a.sent();
                    return [2, sdk.models.application.create({
                            name: appName,
                            deviceType: deviceType,
                        })];
            }
        });
    });
}
function generateApplicationConfig(sdk, app) {
    return __awaiter(this, void 0, void 0, function () {
        var form, configGen, manifest, opts, values, config;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.resolve().then(function () { return require('resin-cli-form'); })];
                case 1:
                    form = _a.sent();
                    return [4, Promise.resolve().then(function () { return require('./config'); })];
                case 2:
                    configGen = (_a.sent()).generateApplicationConfig;
                    return [4, sdk.models.device.getManifestBySlug(app.device_type)];
                case 3:
                    manifest = _a.sent();
                    opts = manifest.options && manifest.options.filter(function (opt) { return opt.name !== 'network'; });
                    return [4, form.run(opts)];
                case 4:
                    values = _a.sent();
                    return [4, configGen(app, values)];
                case 5:
                    config = _a.sent();
                    if (config.connectivity === 'connman') {
                        delete config.connectivity;
                        delete config.files;
                    }
                    return [2, config];
            }
        });
    });
}
var templateObject_1;
//# sourceMappingURL=promote.js.map