"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var Bluebird = require("bluebird");
var typed_error_1 = require("typed-error");
var helpers_1 = require("./helpers");
var ExecError = (function (_super) {
    __extends(ExecError, _super);
    function ExecError(cmd, exitCode) {
        var _this = _super.call(this, "Command '" + cmd + "' failed with error: " + exitCode) || this;
        _this.cmd = cmd;
        _this.exitCode = exitCode;
        return _this;
    }
    return ExecError;
}(typed_error_1.TypedError));
exports.ExecError = ExecError;
function exec(deviceIp, cmd, stdout) {
    return __awaiter(this, void 0, void 0, function () {
        var command, stdio, _a, program, args, exitCode;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    command = "ssh \t\t-t \t\t-p 22222 \t\t-o LogLevel=ERROR \t\t-o StrictHostKeyChecking=no \t\t-o UserKnownHostsFile=/dev/null \t\troot@" + deviceIp + " \t\t" + cmd;
                    stdio = ['ignore', stdout ? 'pipe' : 'inherit', 'ignore'];
                    _a = helpers_1.getSubShellCommand(command), program = _a.program, args = _a.args;
                    return [4, new Bluebird(function (resolve, reject) {
                            var ps = child_process_1.spawn(program, args, { stdio: stdio })
                                .on('error', reject)
                                .on('close', resolve);
                            if (stdout) {
                                ps.stdout.pipe(stdout);
                            }
                        })];
                case 1:
                    exitCode = _b.sent();
                    if (exitCode != 0) {
                        throw new ExecError(cmd, exitCode);
                    }
                    return [2];
            }
        });
    });
}
exports.exec = exec;
function execBuffered(deviceIp, cmd, enc) {
    return __awaiter(this, void 0, void 0, function () {
        var through, buffer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.resolve().then(function () { return require('through2'); })];
                case 1:
                    through = _a.sent();
                    buffer = [];
                    return [4, exec(deviceIp, cmd, through(function (data, _enc, cb) {
                            buffer.push(data.toString(enc));
                            cb();
                        }))];
                case 2:
                    _a.sent();
                    return [2, buffer.join('')];
            }
        });
    });
}
exports.execBuffered = execBuffered;
//# sourceMappingURL=ssh.js.map