"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var UpdateNotifier = require("update-notifier");
var isRoot = require("is-root");
var packageJSON = require("../../package.json");
var resinUpdateInterval = 1000 * 60 * 60 * 24 * 1;
var notifier;
if (!isRoot()) {
    notifier = UpdateNotifier({
        pkg: packageJSON,
        updateCheckInterval: resinUpdateInterval,
    });
}
function notify() {
    if (!notifier) {
        return;
    }
    notifier.notify({ defer: false });
    if (notifier.update != null) {
        console.log('Notice that you might need administrator privileges depending on your setup\n');
    }
}
exports.notify = notify;
//# sourceMappingURL=update.js.map